							/* * * * * * * * * * * * *
							 *    *
							 * * * * * * * * * * * * */

#define F_CPU 8000000UL   /* */
#include <avr/io.h>        /* -*/


							/* * * * * * * * * * * * * * * * *
							 *   ATMega16 *
							 * * * * * * * * * * * * * * * * */

void IO_Init (void)
{
	MCUCSR |= 0b10000000; /*   JTAG*/
	MCUCSR |= 0b10000000; /*  2-5  */

	DDRA = 0b11111111; /* A*/
	PORTA = 0b00000000;

	DDRB = 0b11111111; /* B*/
	PORTB = 0b00000000;

	DDRC = 0b00000011; /* C*/
	PORTC = 0b11111100;

	DDRD = 0b00000000; /* D*/
	PORTD = 0b11111111;
}


							/* * * * * * * * * * *
							 *  LCD *
							 * * * * * * * * * * */
void LCD_Init (void)     
{
	Pause(100);
	LCD_Command(0b00100000); /*    */
	LCD_Command(0b00100000);
	LCD_Command(0b11000000);
	Pause(50);
	LCD_Command(0b00000000); /*  */
	LCD_Command(0b11000000);
	Pause(50);
	LCD_Command(0b00000000); /* */
	LCD_Command(0b00010000);
	Pause(50);
	LCD_Command(0b00000000); /*   */
	LCD_Command(0b01100000);
}


							/* * * * * * * * * * * * *
							 *    LCD *
							 * * * * * * * * * * * * */

void LCD_Command (unsigned char Command)	               
{ 
asm("cli");
	PORTB &= 0b11111110;                  /* RS=0 ()*/

	PORTB &= 0b10000111;                  /*  */
	PORTB |= (Command >> 1) & 0b01111000; /*   */
	PORTB |= 0b00000010;                  /*   E=1*/
	asm("nop");                           /*      */
	PORTB &= 0b11111101;                  /*   E=0*/
	
	asm("nop");                           /*      */
	
	PORTB &= 0b10000111;                  /*  */
	PORTB |= (Command << 3) & 0b01111000; /*   */
	PORTB |= 0b00000010;                  /*   E=1*/
	asm("nop");                           /*      */
	PORTB &= 0b11111101;                  /*   E=0*/

	PORTB |= 0b01111000;                  /*      (1)*/
asm("sei");
}


							/* * * * * * * * * * * * *
							 *    LCD *
							 * * * * * * * * * * * * */

void LCD_Data (unsigned char Command)	               
{ 
asm("cli");
	PORTB |= 0b00000001;                  /* RS=0 ()*/

	PORTB &= 0b10000111;                  /*  */
	PORTB |= (Command >> 1) & 0b01111000; /*   */
	PORTB |= 0b00000010;                  /*   E=1*/
	asm("nop");                           /*      */
	PORTB &= 0b11111101;                  /*   E=0*/
	
	asm("nop");                           /*      */
	
	PORTB &= 0b10000111;                  /*  */
	PORTB |= (Command << 3) & 0b01111000; /*   */
	PORTB |= 0b00000010;                  /*   E=1*/
	asm("nop");                           /*      */
	PORTB &= 0b11111101;                  /*   E=0*/

	PORTB |= 0b01111000;                  /*      (1)*/
asm("sei");
}
 
							/* * * * * * * * * * * * 
							 *   *
							 * * * * * * * * * * * */

int main (void)
{
	
	IO_Init();      /* */
	LCD_Init();     /* LCD*/
	while(1)        /* -*/
	{
		Pause(100);
		if( PORTC & 0b00000001 ){PORTC &= 0b11111110;}else{PORTC |= 0b00000001;}
		LCD_Command(0b00000001); //  
		LCD_Draw();
	}
	return 1;
}

/* */
void Pause (unsigned int Interval)				
{   /* +26*    */
	unsigned int i; //    
	for (i=0;i<(Interval*208+1);i++){asm("nop");}; //   
}

							/* * * * * * * * * * * * *
							 *   LCD  *
							 * * * * * * * * * * * * */
void LCD_Draw()
{
	if( PIND & 0b01111111 )
	{
		/*     */
	}else{
		LCD_Command(0b00000001); //  
		LCD_Data('O');
		LCD_Data('S');
		LCD_Data('T');
		LCD_Data('R');
		LCD_Data('O');
	}
}
